//----------------------------------------------------------------------//
// NyanFi																//
//  t@C̏_CAO										//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <System.DateUtils.hpp>
#include <RegularExpressions.hpp>
#include "Global.h"
#include "UserFunc.h"
#include "UserMdl.h"
#include "SameDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSameNameDlg *SameNameDlg;

//---------------------------------------------------------------------------
__fastcall TSameNameDlg::TSameNameDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TSameNameDlg::FormCreate(TObject *Sender)
{
	CopyAll    = false;
	CopyMode   = 0;
	IsSamePath = false;
	TaskNo	   = -1;
	InhAllChk  = false;

	CurSrcName = CurDstName = EmptyStr;

	set_ListBoxItemHi(InfoListBox);
}
//---------------------------------------------------------------------------
void __fastcall TSameNameDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	InfoListBox->Color = col_bgInf;

	UnicodeString tmp;

	InhAllChk = true;
	if (CopyMode!=4) {
		tmp.sprintf(_T("SameDlgCopyAll%u"), TaskNo + 1);
		AllCheckBox->Checked = CopyAll = IniFile->ReadBoolGen(tmp.c_str(), true);
	}
	else
		AllCheckBox->Checked = CopyAll = false;
	InhAllChk = false;

	Mode0Btn->Enabled = !IsSamePath;
	Mode1Btn->Enabled = !IsSamePath;
	Mode2Btn->Enabled = !IsSamePath;

	if (IsSamePath && CopyMode<3) CopyMode = 4;

	switch (CopyMode) {
	case 0: Mode0Btn->Checked = true; break;
	case 1: Mode1Btn->Checked = true; break;
	case 2: Mode2Btn->Checked = true; break;
	case 3: Mode3Btn->Checked = true; break;
	case 4: Mode4Btn->Checked = true; break;
	}

	ModeBtnClick(NULL);

	InfoListBox->Clear();
	InfoListBox->Items->Add(ExtractFileName(CurSrcName));

	UnicodeString dnam = ExtractFileDir(CurSrcName);
	if (is_match_regex(dnam, _T("^\\\\[^\\\\]"))) dnam = yen_to_slash(dnam);
	tmp.sprintf(_T(": %s"), dnam);
	InfoListBox->Items->Add(tmp);
	InfoListBox->Items->Add(EmptyStr);

	dnam = ExtractFileDir(CurDstName);
	if (is_match_regex(dnam, _T("^\\\\[^\\\\]"))) dnam = yen_to_slash(dnam);
	tmp.sprintf(_T(": %s"), dnam);
	InfoListBox->Items->Add(tmp);
	InfoListBox->Items->Add(EmptyStr);

	tmp.USET_T("TCY: ");
	if (CurSrcSize == CurDstSize)
		tmp.UCAT_T("");
	else
		tmp.cat_sprintf(_T("]̕%s"), (CurSrcSize<CurDstSize)? _T("傫") : _T(""));
	InfoListBox->Items->Add(tmp);

	tmp.USET_T("^C: ");
	if (WithinPastMilliSeconds(CurSrcTime, CurDstTime, TimeTolerance)) {
		tmp.UCAT_T("");
		if (CurSrcTime!=CurDstTime) tmp.UCAT_T(" (e덷)");
	}
	else
		tmp.cat_sprintf(_T("]̕%s"), (CurSrcTime<CurDstTime)? _T("V") : _T("Â"));
	InfoListBox->Items->Add(tmp);
}
//---------------------------------------------------------------------------
void __fastcall TSameNameDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->SavePosInfo(this);

	if (CopyMode!=4) {
		UnicodeString key;
		key.sprintf(_T("SameDlgCopyAll%u"), TaskNo + 1);
		IniFile->WriteBoolGen(key.c_str(), CopyAll);
	}
}

//---------------------------------------------------------------------------
//[hύX
//---------------------------------------------------------------------------
void __fastcall TSameNameDlg::ModeBtnClick(TObject *Sender)
{
	RenameEdit->Enabled = false;

	if (Mode0Btn->Checked) {
		CopyMode = 0;
		Mode0Btn->SetFocus();
	}
	else if (Mode1Btn->Checked) {
		CopyMode = 1;
		Mode1Btn->SetFocus();
	}
	else if (Mode2Btn->Checked) {
		CopyMode = 2;
		Mode2Btn->SetFocus();
	}
	else if (Mode3Btn->Checked) {
		CopyMode = 3;
		Mode3Btn->SetFocus();
	}
	else if (Mode4Btn->Checked) {
		CopyMode = 4;
		SameNameDlg->AllCheckBox->Checked = CopyAll = false;
		RenameEdit->Enabled = true;
		RenameEdit->SetFocus();
		int p = pos_r(_T("."), RenameEdit->Text) - 1;
		if (p<0) p = RenameEdit->Text.Length();
		RenameEdit->SelStart = p;
	}
}
//---------------------------------------------------------------------------
void __fastcall TSameNameDlg::AllCheckBoxClick(TObject *Sender)
{
	if (InhAllChk) return;

	CopyAll = SameNameDlg->AllCheckBox->Checked;
	Mode4Btn->Enabled = !CopyAll;
	if (CopyAll && Mode4Btn->Checked) Mode3Btn->Checked = true;
	RenameEdit->Enabled = Mode4Btn->Checked;
}

//---------------------------------------------------------------------------
//񗓂̕`
//---------------------------------------------------------------------------
void __fastcall TSameNameDlg::InfoListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Brush->Color = col_bgInf;
	cv->FillRect(Rect);
	int xp = Rect.Left + 4;

	if (Index==2 || Index==4) {
		//TCY
		UnicodeString lbuf = "    " + get_FileSizeStr((Index==2)? CurSrcSize : CurDstSize) + " ";
		cv->Font->Color = col_fgList;
		cv->TextOut(xp, Rect.Top + 1, lbuf);
		xp += cv->TextWidth(lbuf);
		//^C
		TDateTime dt = (Index==2)? CurSrcTime : CurDstTime;
		cv->Font->Color = get_TimeColor(dt, col_fgList);
		cv->TextOut(xp, Rect.Top + 1, format_DateTime(dt));
	}
	else {
		UnicodeString lbuf = lp->Items->Strings[Index];
		switch (Index) {
		case 0:
			cv->Font->Color = get_ExtColor(ExtractFileExt(lbuf)); break;
		case 1: case 3:
			cv->Font->Color = col_Folder; break;
		default:
			cv->Font->Color = col_fgList;
		}
		lbuf = minimize_str(lbuf, cv, Rect.Width()-8, OmitEndOfName);
		cv->TextOut(Rect.Left + 4, Rect.Top + 1, lbuf);
	}
}

//---------------------------------------------------------------------------
//Oł̃L[
//---------------------------------------------------------------------------
void __fastcall TSameNameDlg::RenameEditKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (!Shift.Empty()) return;

	if		(Key==VK_UP)	{ Mode3Btn->SetFocus();		Key = 0; }
	else if	(Key==VK_DOWN)	{ AllCheckBox->SetFocus();	Key = 0; }
}

//---------------------------------------------------------------------------
void __fastcall TSameNameDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}
//---------------------------------------------------------------------------
